# /* Robert Meolic, 13. 9. 2002 */
# /* Primer za Zagreb 2004 */

set model "rejective"
pa_read_sort "sortDME-martin.dat"

pa_read_process "fork1abc.dat"
pa_read_process "or2abc.dat"
pa_read_process "and2abc.dat"
pa_read_process "c2abc.dat"
pa_read_process "mez3abcde.dat"
pa_read_process "rsqb2abcd.dat"

pa_encode_process "fork1abc0-$model"
pa_encode_process "fork1abc1-$model"
pa_encode_process "and2abc00-$model"
pa_encode_process "and2abc01-$model"
pa_encode_process "and2abc10-$model"
pa_encode_process "and2abc11-$model"
pa_encode_process "or2abc00-$model"
pa_encode_process "or2abc01-$model"
pa_encode_process "or2abc10-$model"
pa_encode_process "or2abc11-$model"
pa_encode_process "c2abc01-$model"
pa_encode_process "mez3abcde000-$model"
pa_encode_process "rsqb2abcd0001-$model"
pa_encode_process "rsqb2abcd0010-$model"

pa_copy_process mez3abcde000-$model MEurlrinhul NULL "a b c d e" "ur lr inh u l"
pa_copy_process or2abc00-$model ORulqi NULL "a b c" "u l qi"
pa_copy_process and2abc00-$model ANDuqoy1 NULL "a b c" "u qo y1"
pa_copy_process and2abc00-$model ANDlqoi5 NULL "a b c" "l qo i5"
pa_copy_process c2abc01-$model Cy1i4i7 NULL "a b c" "y1 i4 i7"
pa_copy_process c2abc01-$model Ci5i1i9 NULL "a b c" "i5 i1 i9"
pa_copy_process or2abc00-$model ORi8i4i3 NULL "a b c" "i8 i4 i3"
pa_copy_process or2abc00-$model ORi1i10i2 NULL "a b c" "i1 i10 i2"
pa_copy_process or2abc00-$model ORi3i2inh NULL "a b c" "i3 i2 inh"
pa_copy_process and2abc10-$model ANDqoi8s NULL "a b c" "qo i8 s"
pa_copy_process and2abc10-$model ANDqoi10r NULL "a b c" "qo i10 r"
pa_copy_process or2abc00-$model ORi6raqo NULL "a b c" "i6 ra qo"
pa_copy_process fork1abc0-$model FORKi7i8ua NULL "a b c" "i7 i8 ua"
pa_copy_process fork1abc0-$model FORKi9i10la NULL "a b c" "i9 i10 la"

pa_copy_process rsqb2abcd0001-$model RSrsqqb01 NULL "a b c d" "r s q qb"
pa_copy_process and2abc00-$model ANDsqi40 NULL "a b c" "s q i4"
pa_copy_process and2abc00-$model ANDqiqi60 NULL "a b c" "qi q i6"
pa_copy_process and2abc01-$model ANDrqbi11 NULL "a b c" "r qb i1"
pa_copy_process and2abc10-$model ANDqbqirr1 NULL "a b c" "qb qi rr"

pa_copy_process rsqb2abcd0010-$model RSrsqqb10 NULL "a b c d" "r s q qb"
pa_copy_process and2abc01-$model ANDsqi41 NULL "a b c" "s q i4"
pa_copy_process and2abc01-$model ANDqiqi61 NULL "a b c" "qi q i6"
pa_copy_process and2abc00-$model ANDrqbi10 NULL "a b c" "r qb i1"
pa_copy_process and2abc00-$model ANDqbqirr0 NULL "a b c" "qb qi rr"

pa_encode_process "MEurlrinhul ORulqi ANDuqoy1 ANDlqoi5 Cy1i4i7 Ci5i1i9 ORi8i4i3 ORi1i10i2 ORi3i2inh ANDqoi8s ANDqoi10r ORi6raqo FORKi7i8ua FORKi9i10la"
pa_encode_process "RSrsqqb01 ANDsqi40 ANDqiqi60 ANDrqbi11 ANDqbqirr1"
pa_encode_process "RSrsqqb10 ANDsqi41 ANDqiqi61 ANDrqbi10 ANDqbqirr0"

# -----------------------------------------------

outline ""
outline " ==========================="
outline " COMPOSITION OF PROCESSES"
outline " ==========================="
outline ""

versis_compose 7 DME-false \
  "MEurlrinhul ORulqi ANDuqoy1 ANDlqoi5 Cy1i4i7 Ci5i1i9 ORi8i4i3 ORi1i10i2 ORi3i2inh ANDqoi8s ANDqoi10r ORi6raqo FORKi7i8ua FORKi9i10la RSrsqqb01 ANDsqi40 ANDqiqi60 ANDrqbi11 ANDqbqirr1" \
  "ur ua lr la rr ra"

versis_compose 7 DME-true \
  "MEurlrinhul ORulqi ANDuqoy1 ANDlqoi5 Cy1i4i7 Ci5i1i9 ORi8i4i3 ORi1i10i2 ORi3i2inh ANDqoi8s ANDqoi10r ORi6raqo FORKi7i8ua FORKi9i10la RSrsqqb10 ANDsqi41 ANDqiqi61 ANDrqbi10 ANDqbqirr0" \
  "ur ua lr la rr ra"

# -----------------------------------------------

outline ""
outline " =============================="
outline " CREATE ABSTRACTED PROCESSES"
outline " =============================="
outline ""

pa_copy_process DME-false ABS-DME-false-ua NULL "la rr" "tau tau"
pa_copy_process DME-true ABS-DME-true-ua NULL "la rr" "tau tau"

pa_encode_process "ABS-DME-false-ua"
pa_encode_process "ABS-DME-true-ua"

versis_trace_minimization 0 ABS-DME-false-ua
versis_trace_minimization 0 ABS-DME-true-ua

pa_copy_process TRACE_ABS-DME-false-ua DME-false-ua NULL "" ""
pa_copy_process TRACE_ABS-DME-true-ua DME-true-ua NULL "" ""

pa_encode_process "DME-false-ua DME-true-ua"

# -----------------------------------------------

outline ""
outline " ======================"
outline " INFO ABOUT PROCESSES"
outline " ======================"
outline ""

outline "DME-false has [pa_state_number DME-false] states / [pa_transition_number DME-false] transitions."
outline "DME-false-ua has [pa_state_number DME-false-ua] states / [pa_transition_number DME-false-ua] transitions."
outline ""
outline "DME-true has [pa_state_number DME-true] states / [pa_transition_number DME-true] transitions."
outline "DME-true-ua has [pa_state_number DME-true-ua] states / [pa_transition_number DME-true-ua] transitions."

# -----------------------------------------------

outline ""
outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line UA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-false-ua "zagreb.actl" automaton

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line UA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-true-ua "zagreb.actl" automaton
