# /* Robert Meolic, 27. 7. 2005 */
# /* Ph.D. */

set model "rejective"

pa_read_process "sortDME-martin.dat"

pa_read_process "fork1abc.dat"
pa_read_process "or2abc.dat"
pa_read_process "and2abc.dat"
pa_read_process "c2abc.dat"
pa_read_process "mez3abcde.dat"
pa_read_process "rsqb2abcd.dat"

pa_copy_process mez3abcde000-$model MEurlrinhul NULL "a b c d e" "ur lr inh u l"
pa_copy_process or2abc00-$model ORulqi NULL "a b c" "u l qi"
pa_copy_process and2abc00-$model ANDuqoy1 NULL "a b c" "u qo y1"
pa_copy_process and2abc00-$model ANDlqoi5 NULL "a b c" "l qo i5"
pa_copy_process c2abc01-$model Cy1i4i7 NULL "a b c" "y1 i4 i7"
pa_copy_process c2abc01-$model Ci5i1i9 NULL "a b c" "i5 i1 i9"
pa_copy_process or2abc00-$model ORi8i4i3 NULL "a b c" "i8 i4 i3"
pa_copy_process or2abc00-$model ORi1i10i2 NULL "a b c" "i1 i10 i2"
pa_copy_process or2abc00-$model ORi3i2inh NULL "a b c" "i3 i2 inh"
pa_copy_process and2abc10-$model ANDqoi8s NULL "a b c" "qo i8 s"
pa_copy_process and2abc10-$model ANDqoi10r NULL "a b c" "qo i10 r"
pa_copy_process or2abc00-$model ORi6raqo NULL "a b c" "i6 ra qo"
pa_copy_process fork1abc0-$model FORKi7i8ua NULL "a b c" "i7 i8 ua"
pa_copy_process fork1abc0-$model FORKi9i10la NULL "a b c" "i9 i10 la"

pa_copy_process rsqb2abcd0001-$model RSrsqqb01 NULL "a b c d" "r s q qb"
pa_copy_process and2abc00-$model ANDsqi40 NULL "a b c" "s q i4"
pa_copy_process and2abc00-$model ANDqiqi60 NULL "a b c" "qi q i6"
pa_copy_process and2abc01-$model ANDrqbi11 NULL "a b c" "r qb i1"
pa_copy_process and2abc10-$model ANDqbqirr1 NULL "a b c" "qb qi rr"

pa_copy_process rsqb2abcd0010-$model RSrsqqb10 NULL "a b c d" "r s q qb"
pa_copy_process and2abc01-$model ANDsqi41 NULL "a b c" "s q i4"
pa_copy_process and2abc01-$model ANDqiqi61 NULL "a b c" "qi q i6"
pa_copy_process and2abc00-$model ANDrqbi10 NULL "a b c" "r qb i1"
pa_copy_process and2abc00-$model ANDqbqirr0 NULL "a b c" "qb qi rr"

pa_encode_process "MEurlrinhul"
pa_encode_process "ORulqi"
pa_encode_process "ANDuqoy1"
pa_encode_process "ANDlqoi5"
pa_encode_process "Cy1i4i7"
pa_encode_process "Ci5i1i9"
pa_encode_process "ORi8i4i3"
pa_encode_process "ORi1i10i2"
pa_encode_process "ORi3i2inh"
pa_encode_process "ANDqoi8s"
pa_encode_process "ANDqoi10r"
pa_encode_process "ORi6raqo"
pa_encode_process "FORKi7i8ua"
pa_encode_process "FORKi9i10la"

pa_encode_process "RSrsqqb01"
pa_encode_process "ANDsqi40"
pa_encode_process "ANDqiqi60"
pa_encode_process "ANDrqbi11"
pa_encode_process "ANDqbqirr1"

pa_encode_process "RSrsqqb10"
pa_encode_process "ANDsqi41"
pa_encode_process "ANDqiqi61"
pa_encode_process "ANDrqbi10"
pa_encode_process "ANDqbqirr0"

# -----------------------------------------------

outline ""
outline " ==========================="
outline " COMPOSITION OF PROCESSES"
outline " ==========================="
outline ""

versis_compose 7 DME-false \
  "MEurlrinhul ORulqi ANDuqoy1 ANDlqoi5 Cy1i4i7 Ci5i1i9 ORi8i4i3 ORi1i10i2 ORi3i2inh ANDqoi8s ANDqoi10r ORi6raqo FORKi7i8ua FORKi9i10la RSrsqqb01 ANDsqi40 ANDqiqi60 ANDrqbi11 ANDqbqirr1" \
  "ur ua lr la rr ra"

versis_compose 7 DME-true \
  "MEurlrinhul ORulqi ANDuqoy1 ANDlqoi5 Cy1i4i7 Ci5i1i9 ORi8i4i3 ORi1i10i2 ORi3i2inh ANDqoi8s ANDqoi10r ORi6raqo FORKi7i8ua FORKi9i10la RSrsqqb10 ANDsqi41 ANDqiqi61 ANDrqbi10 ANDqbqirr0" \
  "ur ua lr la rr ra"

# -----------------------------------------------

outline ""
outline " =============================="
outline " CREATE ABSTRACTED PROCESSES"
outline " =============================="
outline ""

pa_copy_process DME-false ABS-DME-false-ua NULL "la rr" "tau tau"
pa_copy_process DME-false ABS-DME-false-la NULL "ua rr" "tau tau"
pa_copy_process DME-false ABS-DME-false-rr NULL "ua la" "tau tau"

pa_copy_process DME-true ABS-DME-true-ua NULL "la rr" "tau tau"
pa_copy_process DME-true ABS-DME-true-la NULL "ua rr" "tau tau"
pa_copy_process DME-true ABS-DME-true-rr NULL "ua la" "tau tau"

pa_encode_process "ABS-DME-false-ua"
pa_encode_process "ABS-DME-false-la"
pa_encode_process "ABS-DME-false-rr"

pa_encode_process "ABS-DME-true-ua"
pa_encode_process "ABS-DME-true-la"
pa_encode_process "ABS-DME-true-rr"

versis_trace_minimization 0 ABS-DME-false-ua
versis_trace_minimization 0 ABS-DME-false-la
versis_trace_minimization 0 ABS-DME-false-rr

versis_trace_minimization 0 ABS-DME-true-ua
versis_trace_minimization 0 ABS-DME-true-la
versis_trace_minimization 0 ABS-DME-true-rr

pa_copy_process TRACE_ABS-DME-false-ua DME-false-ua NULL "" ""
pa_copy_process TRACE_ABS-DME-false-la DME-false-la NULL "" ""
pa_copy_process TRACE_ABS-DME-false-rr DME-false-rr NULL "" ""

pa_copy_process TRACE_ABS-DME-true-ua DME-true-ua NULL "" ""
pa_copy_process TRACE_ABS-DME-true-la DME-true-la NULL "" ""
pa_copy_process TRACE_ABS-DME-true-rr DME-true-rr NULL "" ""

pa_encode_process "DME-false-ua"
pa_encode_process "DME-false-la"
pa_encode_process "DME-false-rr"

pa_encode_process "DME-true-ua"
pa_encode_process "DME-true-la"
pa_encode_process "DME-true-rr"

# -----------------------------------------------

outline ""
outline " ======================"
outline " INFO ABOUT PROCESSES"
outline " ======================"
outline ""

outline "C element has [pa_state_number Cy1i4i7] states / [pa_transition_number Cy1i4i7] transitions / [bdd_node_number D_Cy1i4i7] BDD nodes."
outline "RS flip-flop-false has [pa_state_number RSrsqqb01] states / [pa_transition_number RSrsqqb01] transitions / [bdd_node_number D_RSrsqqb01] BDD nodes."
outline "RS flip-flop-true has [pa_state_number RSrsqqb10] states / [pa_transition_number RSrsqqb10] transitions / [bdd_node_number D_RSrsqqb10] BDD nodes."
outline "MEz element has [pa_state_number MEurlrinhul] states / [pa_transition_number MEurlrinhul] transitions / [bdd_node_number D_MEurlrinhul] BDD nodes."
outline ""
outline "DME-false has [pa_state_number DME-false] states / [pa_transition_number DME-false] transitions / [bdd_node_number D_DME-false] BDD nodes."
outline "DME-true has [pa_state_number DME-true] states / [pa_transition_number DME-true] transitions / [bdd_node_number D_DME-true] BDD nodes."
outline ""
outline "DME-false-ua has [pa_state_number DME-false-ua] states / [pa_transition_number DME-false-ua] transitions / [bdd_node_number D_DME-false-ua] BDD nodes."
outline "DME-false-la has [pa_state_number DME-false-la] states / [pa_transition_number DME-false-la] transitions / [bdd_node_number D_DME-false-la] BDD nodes."
outline "DME-false-rr has [pa_state_number DME-false-rr] states / [pa_transition_number DME-false-rr] transitions / [bdd_node_number D_DME-false-rr] BDD nodes."
outline "DME-true-ua has [pa_state_number DME-true-ua] states / [pa_transition_number DME-true-ua] transitions / [bdd_node_number D_DME-true-ua] BDD nodes."
outline "DME-true-la has [pa_state_number DME-true-la] states / [pa_transition_number DME-true-la] transitions / [bdd_node_number D_DME-true-la] BDD nodes."
outline "DME-true-rr has [pa_state_number DME-true-rr] states / [pa_transition_number DME-true-rr] transitions / [bdd_node_number D_DME-true-rr] BDD nodes."
outline ""

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line UA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-false-ua "dme-cell-static.actl"
mc_check_actl_file 0 DME-false-ua "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-false-ua "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line LA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-false-la "dme-cell-static.actl"
mc_check_actl_file 0 DME-false-la "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-false-la "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line RR"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-false-rr "dme-cell-static.actl"
mc_check_actl_file 0 DME-false-rr "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-false-rr "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line UA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-true-ua "dme-cell-static.actl"
mc_check_actl_file 0 DME-true-ua "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-true-ua "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line LA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-true-la "dme-cell-static.actl"
mc_check_actl_file 0 DME-true-la "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-true-la "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line RR"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-true-rr "dme-cell-static.actl"
mc_check_actl_file 0 DME-true-rr "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-true-rr "dme-cell-steady.actl"
