# /* Robert Meolic, 27. 7. 2005 */
# /* Ph.D */

set model "rejective"

pa_read_process "sortDME-smv.dat"

pa_read_process "fork1abc.dat"
pa_read_process "or2abc.dat"
pa_read_process "and2abc.dat"
pa_read_process "c2abc.dat"
pa_read_process "me2abcd.dat"
pa_read_process "rsqb2abcd.dat"

pa_copy_process me2abcd00-$model MEurlrab NULL "a b c d" "ur lr A B"
pa_copy_process and2abc01-$model ANDaoc NULL "a b c" "A O C"
pa_copy_process and2abc10-$model ANDpbd NULL "a b c" "P B D"
pa_copy_process c2abc00-$model Ccie NULL "a b c" "C I E"
pa_copy_process c2abc00-$model Cdif NULL "a b c" "D I F"
pa_copy_process or2abc00-$model ORcdg NULL "a b c" "C D G"
pa_copy_process c2abc00-$model Cgjh NULL "a b c" "G J H"
pa_copy_process and2abc01-$model ANDhji NULL "a b c" "H J I"
pa_copy_process or2abc00-$model ORlraj NULL "a b c" "L ra J"
pa_copy_process and2abc01-$model ANDghk NULL "a b c" "G H K"
pa_copy_process fork1abc0-$model FORKqola NULL "a b c" "Q O la"
pa_copy_process fork1abc0-$model FORKrpua NULL "a b c" "R P ua"

pa_copy_process rsqb2abcd0001-$model RSfemn01 NULL "a b c d" "F E M N"
pa_copy_process and2abc00-$model ANDemr0 NULL "a b c" "E M R"
pa_copy_process and2abc00-$model ANDkml0 NULL "a b c" "K M L"
pa_copy_process and2abc01-$model ANDfnq1 NULL "a b c" "F N Q"
pa_copy_process and2abc10-$model ANDnkrr1 NULL "a b c" "N K rr"

pa_copy_process rsqb2abcd0010-$model RSfemn10 NULL "a b c d" "F E M N"
pa_copy_process and2abc01-$model ANDemr1 NULL "a b c" "E M R"
pa_copy_process and2abc01-$model ANDkml1 NULL "a b c" "K M L"
pa_copy_process and2abc00-$model ANDfnq0 NULL "a b c" "F N Q"
pa_copy_process and2abc00-$model ANDnkrr0 NULL "a b c" "N K rr"

pa_encode_process "MEurlrab"
pa_encode_process "ANDaoc"
pa_encode_process "ANDpbd"
pa_encode_process "Ccie"
pa_encode_process "Cdif"
pa_encode_process "ORcdg"
pa_encode_process "Cgjh"
pa_encode_process "ANDhji"
pa_encode_process "ORlraj"
pa_encode_process "ANDghk"
pa_encode_process "FORKqola"
pa_encode_process "FORKrpua"

pa_encode_process "RSfemn01"
pa_encode_process "ANDemr0"
pa_encode_process "ANDkml0"
pa_encode_process "ANDfnq1"
pa_encode_process "ANDnkrr1"

pa_encode_process "RSfemn10"
pa_encode_process "ANDemr1"
pa_encode_process "ANDkml1"
pa_encode_process "ANDfnq0"
pa_encode_process "ANDnkrr0"

# -----------------------------------------------

outline ""
outline " ==========================="
outline " COMPOSITION OF PROCESSES"
outline " ==========================="
outline ""

versis_compose 7 DME-false \
  "MEurlrab ANDaoc ANDpbd Ccie Cdif ORcdg Cgjh ANDhji ORlraj ANDghk RSfemn01 ANDkml0 ANDemr0 ANDfnq1 ANDnkrr1 FORKqola FORKrpua" \
  "ur ua lr la rr ra"

versis_compose 7 DME-true \
  "MEurlrab ANDaoc ANDpbd Ccie Cdif ORcdg Cgjh ANDhji ORlraj ANDghk RSfemn10 ANDkml1 ANDemr1 ANDfnq0 ANDnkrr0 FORKqola FORKrpua" \
  "ur ua lr la rr ra"

# -----------------------------------------------

outline ""
outline " =============================="
outline " CREATE ABSTRACTED PROCESSES"
outline " =============================="
outline ""

pa_copy_process DME-false ABS-DME-false-ua NULL "la rr" "tau tau"
pa_copy_process DME-false ABS-DME-false-la NULL "ua rr" "tau tau"
pa_copy_process DME-false ABS-DME-false-rr NULL "ua la" "tau tau"

pa_copy_process DME-true ABS-DME-true-ua NULL "la rr" "tau tau"
pa_copy_process DME-true ABS-DME-true-la NULL "ua rr" "tau tau"
pa_copy_process DME-true ABS-DME-true-rr NULL "ua la" "tau tau"

pa_encode_process "ABS-DME-false-ua"
pa_encode_process "ABS-DME-false-la"
pa_encode_process "ABS-DME-false-rr"

pa_encode_process "ABS-DME-true-ua"
pa_encode_process "ABS-DME-true-la"
pa_encode_process "ABS-DME-true-rr"

versis_trace_minimization 0 ABS-DME-false-ua
versis_trace_minimization 0 ABS-DME-false-la
versis_trace_minimization 0 ABS-DME-false-rr

versis_trace_minimization 0 ABS-DME-true-ua
versis_trace_minimization 0 ABS-DME-true-la
versis_trace_minimization 0 ABS-DME-true-rr

pa_copy_process TRACE_ABS-DME-false-ua DME-false-ua NULL "" ""
pa_copy_process TRACE_ABS-DME-false-la DME-false-la NULL "" ""
pa_copy_process TRACE_ABS-DME-false-rr DME-false-rr NULL "" ""

pa_copy_process TRACE_ABS-DME-true-ua DME-true-ua NULL "" ""
pa_copy_process TRACE_ABS-DME-true-la DME-true-la NULL "" ""
pa_copy_process TRACE_ABS-DME-true-rr DME-true-rr NULL "" ""

pa_encode_process "DME-false-ua"
pa_encode_process "DME-false-la"
pa_encode_process "DME-false-rr"

pa_encode_process "DME-true-ua"
pa_encode_process "DME-true-la"
pa_encode_process "DME-true-rr"

# -----------------------------------------------

outline ""
outline " ======================"
outline " INFO ABOUT PROCESSES"
outline " ======================"
outline ""

outline "C element has [pa_state_number Ccie] states / [pa_transition_number Ccie] transitions / [bdd_node_number D_Ccie] BDD nodes."
outline "RS flip-flop-false has [pa_state_number RSfemn01] states / [pa_transition_number RSfemn01] transitions / [bdd_node_number D_RSfemn01] BDD nodes."
outline "RS flip-flop-true has [pa_state_number RSfemn10] states / [pa_transition_number RSfemn10] transitions / [bdd_node_number D_RSfemn10] BDD nodes."
outline "ME element has [pa_state_number MEurlrab] states / [pa_transition_number MEurlrab] transitions / [bdd_node_number D_MEurlrab] BDD nodes."
outline ""
outline "DME-false has [pa_state_number DME-false] states / [pa_transition_number DME-false] transitions / [bdd_node_number D_DME-false] BDD nodes."
outline "DME-true has [pa_state_number DME-true] states / [pa_transition_number DME-true] transitions / [bdd_node_number D_DME-true] BDD nodes."
outline ""
outline "DME-false-ua has [pa_state_number DME-false-ua] states / [pa_transition_number DME-false-ua] transitions / [bdd_node_number D_DME-false-ua] BDD nodes."
outline "DME-false-la has [pa_state_number DME-false-la] states / [pa_transition_number DME-false-la] transitions / [bdd_node_number D_DME-false-la] BDD nodes."
outline "DME-false-rr has [pa_state_number DME-false-rr] states / [pa_transition_number DME-false-rr] transitions / [bdd_node_number D_DME-false-rr] BDD nodes."
outline "DME-true-ua has [pa_state_number DME-true-ua] states / [pa_transition_number DME-true-ua] transitions / [bdd_node_number D_DME-true-ua] BDD nodes."
outline "DME-true-la has [pa_state_number DME-true-la] states / [pa_transition_number DME-true-la] transitions / [bdd_node_number D_DME-true-la] BDD nodes."
outline "DME-true-rr has [pa_state_number DME-true-rr] states / [pa_transition_number DME-true-rr] transitions / [bdd_node_number D_DME-true-rr] BDD nodes."
outline ""

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line UA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-false-ua "dme-cell-static.actl"
mc_check_actl_file 0 DME-false-ua "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-false-ua "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line LA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-false-la "dme-cell-static.actl"
mc_check_actl_file 0 DME-false-la "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-false-la "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-false on line RR"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-false-rr "dme-cell-static.actl"
mc_check_actl_file 0 DME-false-rr "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-false-rr "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line UA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-true-ua "dme-cell-static.actl"
mc_check_actl_file 0 DME-true-ua "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-true-ua "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line LA"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-true-la "dme-cell-static.actl"
mc_check_actl_file 0 DME-true-la "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-true-la "dme-cell-steady.actl"

# -----------------------------------------------

outline " ==========================================="
outline " LOOKING FOR HAZARDS in DME-true on line RR"
outline " ==========================================="
outline ""

mc_check_actl_file 0 DME-true-rr "dme-cell-static.actl"
mc_check_actl_file 0 DME-true-rr "dme-cell-dynamic.actl"
mc_check_actl_file 0 DME-true-rr "dme-cell-steady.actl"
