#include <bdd.h>
#include <pa.h>
#include <versis.h>
#include <mc.h>

int main()
{
  /* *********************************************************************** */
  printf("Initialization of BDD package\n");
  /* *********************************************************************** */

  Bdd_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Process algebra package\n");
  /* *********************************************************************** */

  Pa_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Versis package\n");
  /* *********************************************************************** */

  Versis_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Model Checking package\n");
  /* *********************************************************************** */

  Mc_InitPkg();
 
  /* *********************************************************************** */
  printf("pa_read_process <data/dekker/dekker.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/dekker/dekker.dat");

  /* *********************************************************************** */
  printf("pa_encode_sort sortDekker\n");
  /* *********************************************************************** */

  Pa_EncodeSort("sortDekker");

  /* *********************************************************************** */
  printf("pa_encode_process ...\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("B1");
  Pa_EncodeProcess("B2");
  Pa_EncodeProcess("K1");
  Pa_EncodeProcess("P1Tomaz");
  Pa_EncodeProcess("P2Tomaz");

  /* *********************************************************************** */
  printf("versis_compose ...\n");
  /* *********************************************************************** */

  Versis_Compose("DEKKER",1,5,"P1Tomaz P2Tomaz B1 B2 K1",
                  4,"enter1 exit1 enter2 exit2");

  return(1);
}
