#include <bdd.h>
#include <pa.h>
#include <versis.h>
#include <mc.h>

int main()
{
  /* *********************************************************************** */
  printf("Initialization of BDD package\n");
  /* *********************************************************************** */

  Bdd_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Process algebra package\n");
  /* *********************************************************************** */

  Pa_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Versis package\n");
  /* *********************************************************************** */

  Versis_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Model Checking package\n");
  /* *********************************************************************** */

  Mc_InitPkg();
 
  /* *********************************************************************** */
  printf("pa_read_process <data/kva/kva.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/kva/kva.dat");

  /* *********************************************************************** */
  printf("pa_encode_sort sortKVA\n");
  /* *********************************************************************** */

  Pa_EncodeSort("sortKVA");

  /* *********************************************************************** */
  printf("pa_encode_process 3 <krizisce vlak avto>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("krizisce");
  Pa_EncodeProcess("vlak");
  Pa_EncodeProcess("avto");

  /* *********************************************************************** */
  printf("%s\n\t%s\n\t%s\n",
         "versis_compose 1 kva",
         "3 <krizisce vlak avto>",
         "8 <zapD zapG semZ semR vlakP vlakS avtoP avtoS>");
  /* *********************************************************************** */

  Versis_Compose("kva",1,3,"krizisce vlak avto",
                  8,"zapD zapG semZ semR vlakP vlakS avtoP avtoS");

  /* *********************************************************************** */
  printf("mc_check_actl 1 BRP <data/kva/kva.actl>\n");
  /* *********************************************************************** */

  Mc_CheckACTL(1, "kva", "../../data/kva/kva.actl",MC_SIMPLE);

  return(1);
}
