#include <bdd.h>
#include <pa.h>
#include <versis.h>
#include <mc.h>

int main()
{
  Mc_ParserSettings ps;

  /* *********************************************************************** */
  printf("Initialization of BDD package\n");
  /* *********************************************************************** */

  Bdd_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Process algebra package\n");
  /* *********************************************************************** */

  Pa_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Versis package\n");
  /* *********************************************************************** */

  Versis_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Model Checking package\n");
  /* *********************************************************************** */

  Mc_InitPkg();
 
  /* *********************************************************************** */
  printf("pa_read_process <...>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/mcTest/ird.dat");

  /* *********************************************************************** */
  printf("pa_encode_sort ...\n");
  /* *********************************************************************** */

  Pa_EncodeSort("sortIRD");

  /* *********************************************************************** */
  printf("pa_encode_process ... <>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("ird");
  Pa_EncodeProcess("empty");

  /* *********************************************************************** */
  printf("mc_check_actl ...\n");
  /* *********************************************************************** */

  ps.trace = TRUE;
  ps.xtrace = TRUE;
  ps.diagnostic = FALSE;
  ps.explain = FALSE;
  ps.tracepath = FALSE;
  ps.tree = FALSE;

  Mc_CheckACTL(0, "ird", "../../data/mcTest/ird.actl",ps);

  return(1);
}
