#include <bdd.h>
#include <pa.h>
#include <versis.h>

int main()
{
  Bdd_Boolean r;

  /* *********************************************************************** */
  printf("Initialization of BDD package\n");
  /* *********************************************************************** */

  Bdd_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Process algebra package\n");
  /* *********************************************************************** */

  Pa_InitPkg();

  /* *********************************************************************** */
  printf("Initialization of Versis package\n");
  /* *********************************************************************** */

  Versis_InitPkg();
 
  /* *********************************************************************** */
  printf("pa_read_process <data/scheduler/scheduler12.dat>\n");
  /* *********************************************************************** */

  Pa_ParseSortProcess("../../data/scheduler/scheduler12.dat");

  /* *********************************************************************** */
  printf("pa_encode_sort sortSCH12\n");
  /* *********************************************************************** */

  Pa_EncodeSort("sortSCH12");

  /* *********************************************************************** */
  printf(
   "pa_encode_process 13 <starter S1 S2 S3 S4 S5 S6 S7 S8 S9 S10 S11 S12\n"
  );
  /* *********************************************************************** */

  Pa_EncodeProcess("starter");
  Pa_EncodeProcess("S1");
  Pa_EncodeProcess("S2");
  Pa_EncodeProcess("S3");
  Pa_EncodeProcess("S4");
  Pa_EncodeProcess("S5");
  Pa_EncodeProcess("S6");
  Pa_EncodeProcess("S7");
  Pa_EncodeProcess("S8");
  Pa_EncodeProcess("S9");
  Pa_EncodeProcess("S10");
  Pa_EncodeProcess("S11");
  Pa_EncodeProcess("S12");

  /* *********************************************************************** */
  printf("pa_encode_process 1 <SCH12>\n");
  /* *********************************************************************** */

  Pa_EncodeProcess("SCH12");

  /* *********************************************************************** */
  printf("%s\n\t%s\n\t%s\n",
      "versis_compose 1 scheduler",
      "13 <starter S1 S2 S3 S4 S5 S6 S7 S8 S9 S10 S11 S12>",
      "12 <a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12>");
  /* *********************************************************************** */

  Versis_Compose("scheduler",1,
                 13,"starter S1 S2 S3 S4 S5 S6 S7 S8 S9 S10 S11 S12",
                 12,"a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12");

  /* *********************************************************************** */
  printf("versis_weak_equivalence 1 scheduler 0 SCH12\n");
  /* *********************************************************************** */

  r = Versis_Equivalence(1,1,"scheduler",0,"SCH12");
  if (r) printf("TRUE\n"); else printf("FALSE\n");

  return(1);
}
