/**CFile*******************************************************************
  PackageName [ccs]
  Synopsis    [Package 'ccs' provides an extended CCS parser.]

  FileName    [ccsParser.l]
  Revision    [$Revision: 2 $]
  Date        [$Date: 2006-10-05 15:30:29 +0200 (Thu, 05 Oct 2006) $]
  Authors     [Robert Meolic (meolic@uni-mb.si)]
  Description [File ccsParser.l is a flex file for CSS parser.]
  SeeAlso     [ccs.h, ccsInt.h, ccsParser.y]

  Copyright   [see ccs.h]
  ************************************************************************/

PROCESS         agent|Agent|AGENT|process|Process|PROCESS
NET             net|Net|NET
PROPERTY        property|Property|PROPERTY
AUTOMATON       automaton|Automaton|AUTOMATON
PRODUCT         product|Product|PRODUCT
NAME            [-_A-Za-z0-9][-_A-Za-z0-9]*
ACTION          {NAME}[?!]|[?!]{NAME}
TAU             tau|Tau|TAU|i|I
FORMULA         ==.*;

OUTLINE 	#.*
COMMENT         --.*

%%
  int ch, inComm;

"/*"              { for(inComm=1; inComm; )
                    { switch(ch=input())
 			{ case '\n' : break;
			  case '*'  : if (( ch=input()) == '/') inComm=0;
                                        else unput(ch);
				      break;
                        }
                    }
                  }	

[ ]	          {/* preskok praznih mest */}

[\t\n\r]       	  {/* preskok praznega prostora */}

"'"	          {/* qoutes are ignored */}

"\""	          {/* qoutes are ignored */}

{PROCESS}	  {return PROCESS;}

{NET}	          {return NET;}

{PROPERTY}	  {return PROPERTY;}

{AUTOMATON}	  {return AUTOMATON;}

{PRODUCT}	  {return PRODUCT;}

{TAU}         	  {
                   yylval.word = strdup("TAU");
                   return ACTION;
                  }

{NAME}		  {
                   yylval.word = strdup(yytext);
                   return NAME;
                  }

{ACTION}	  {
                   yylval.word = strdup(yytext);
                   return ACTION;
                  }


{FORMULA}	  {
                   yylval.word = strdup(yytext);
                   return FORMULA;
                  }

"|||"	          {return INTERLEAVE;}
"||"	          {return SYNCHRONOUS;}
"|"	          {return COMPOSE;}
"//"	          {return COMPOSE;}
"|["	          {return STARTPARTIAL;}
"]|"	          {return ENDPARTIAL;}

"."	          {return SEP;}
";"	          {return SEP;}

"="	          {return yytext[0];}
"("	          {return yytext[0];}
")"	          {return yytext[0];}
"+"	          {return yytext[0];}

","	          {return yytext[0];}
"["	          {return yytext[0];}
"]"	          {return yytext[0];}
"/"	          {return yytext[0];}
"\\"	          {return yytext[0];}

"@"	          {return yytext[0];}
"*"	          {return SYNPROD;}

{COMMENT}         {};

{OUTLINE}	  {
                   yylval.outline = strdup(yytext);
                   return OUTLINE;
                  }

.                 {
                   return UNKNOWN;
                  }
%%
