#!/bin/sh
# the next line executes the program\
exec wish "$0" "$@"

# MAYBE YOU MUST USE ONE OF THE FOLLOWING LINES
# exec /usr/local/bin/wish "$0" "$@"
# exec /home/meolic/ActiveTcl/bin/wish "$0" "$@"

# $Revision$
# $Date$

#
#  Name        [EST - Efficient Symbolic Tools]
#  Info        [Robert Meolic (meolic@uni-mb.si),
#  Copyright   [Copyright (C) 2000-2006 UM-FERI
#               This program is free software; you can redistribute it
#               and/or modify it under the terms of the GNU General Public
#               License (version 2) as published by the Free Software
#               Foundation.
#
#               This program is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 59 Temple Place, Suite 330,
#               Boston, MA  02111-1307 USA.]
#

global TITLE
global ICONNAME
global PROMPT
global BINDIR

# --------------
# identification
# --------------

set TITLE "EST - Efficient Symbolic Tools"
set ICONNAME "EST"
set PROMPT "EST> "

# ------------
# OS
# ------------

set OS $tcl_platform(platform)

# ------------
# folder 
# ------------

cd [file dirname [info script]]
set BINDIR [pwd]

# ####################################################################
# Start My Interface Tcl/Tk GUI
# ####################################################################

source $BINDIR/mi.tcl

# ####################################################################
# My Interface package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/mi.so}
if {$OS == "windows"} {load $BINDIR/mi.dll}
mi_initPkg

source $BINDIR/miDialog.tcl

# ####################################################################
# Say hello
# ####################################################################

outline "This is Efficient Symbolic Tools, 2nd Edition."
outline "This program is free software, type \"license\" for details."
outline ""

outline "Running on $tcl_platform(machine) ($tcl_platform(os), $tcl_platform(osVersion)) with tcl $tcl_patchLevel and tk $tk_patchLevel." 
outline ""

# ####################################################################
# BDD package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/bdd.so}
if {$OS == "windows"} {load $BINDIR/bdd.dll}
bdd_initPkg

source $BINDIR/bddDialog.tcl

# ####################################################################
# Process algebra package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/pa.so}
if {$OS == "windows"} {load $BINDIR/pa.dll}
pa_initPkg

source $BINDIR/paDialog.tcl

# ####################################################################
# Versis package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/versis.so}
if {$OS == "windows"} {load $BINDIR/versis.dll}
versis_initPkg

source $BINDIR/versisDialog.tcl

# ####################################################################
# Model checking package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/mc.so}
if {$OS == "windows"} {load $BINDIR/mc.dll}
mc_initPkg

source $BINDIR/mcDialog.tcl

# ####################################################################
# Strucval package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/strucval.so}
if {$OS == "windows"} {load $BINDIR/strucval.dll}
strucval_initPkg

source $BINDIR/strucvalDialog.tcl

# ####################################################################
# CCS package
# ####################################################################

if {$OS == "unix"}    {load $BINDIR/ccs.so}
if {$OS == "windows"} {load $BINDIR/ccs.dll}
ccs_initPkg

source $BINDIR/ccsDialog.tcl

# ####################################################################
# EST-IA package
# ####################################################################

#if {$OS == "unix"}    {load $BINDIR/estia.so}
#if {$OS == "windows"} {load $BINDIR/estia.dll}
#estia_initPkg

#source $BINDIR/estiaDialog.tcl

# ####################################################################
# Change to the default folder
# ####################################################################

cd $BINDIR/../data
outline ""
