/**CFile*******************************************************************
  PackageName [estia]
  Synopsis    [Epistemic reasoning]

  FileName    [estiaParser.l]
  Revision    [$Revision: 2 $]
  Date        [$Date: 2006-10-05 15:30:29 +0200 (Thu, 05 Oct 2006) $]
  Authors     [Robert Meolic (meolic@uni-mb.si),
               Marina Bagic (marina.bagic@fer.hr)]
  Description [File estiaParser.l is a flex file for ESTIA parser.]
  SeeAlso     [estia.h, estiaInt.h, estiaParser.y]

  Copyright   [see estia.h]
  ************************************************************************/

PROCESS         agent|Agent|AGENT|process|Process|PROCESS
NET             net|Net|NET
NAME            [-_A-Za-z0-9][-_A-Za-z0-9]*
ACTION          {NAME}[?!]|[?!]{NAME}
TAU             tau|Tau|TAU|i|I

OUTLINE 	#.*
COMMENT         --.*

%%
  int ch, inComm;

"/*"              { for(inComm=1; inComm; )
                    { switch(ch=input())
 			{ case '\n' : break;
			  case '*'  : if (( ch=input()) == '/') inComm=0;
                                        else unput(ch);
				      break;
                        }
                    }
                  }	

[ ]	          {/* preskok praznih mest */}

[\t\n\r]       	  {/* preskok praznega prostora */}

"'"	          {/* qoutes are ignored */}

"\""	          {/* qoutes are ignored */}

{PROCESS}	  {return PROCESS;}

{NET}	          {return NET;}

{TAU}         	  {
                   yylval.word = strdup("TAU");
                   return ACTION;
                  }

{NAME}		  {
                   yylval.word = strdup(yytext);
                   return NAME;
                  }

{ACTION}	  {
                   yylval.word = strdup(yytext);
                   return ACTION;
                  }


"|||"	          {return INTERLEAVE;}
"||"	          {return SYNCHRONOUS;}
"|"	          {return COMPOSE;}
"//"	          {return COMPOSE;}
"|["	          {return STARTPARTIAL;}
"]|"	          {return ENDPARTIAL;}

"."	          {return SEP;}
";"	          {return SEP;}

"="	          {return yytext[0];}
"("	          {return yytext[0];}
")"	          {return yytext[0];}
"+"	          {return yytext[0];}

","	          {return yytext[0];}
"["	          {return yytext[0];}
"]"	          {return yytext[0];}
"/"	          {return yytext[0];}
"\\"	          {return yytext[0];}

{COMMENT}         {};

{OUTLINE}	  {
                   yylval.outline = strdup(yytext);
                   return OUTLINE;
                  }

.                 {
                   return UNKNOWN;
                  }
%%
