global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.mc \
         .menuFrame.mc.menu \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.mc

menubutton .menuFrame.mc -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.mc.menu -pady 1 -text "Model checking"
pack .menuFrame.mc -side left
menu .menuFrame.mc.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.mc.menu add command  -command menu_mc_readACTL -label "mc_read_actl"
.menuFrame.mc.menu add command  -command menu_mc_readACTLFile -label "mc_read_actl_file"
.menuFrame.mc.menu add command  -command menu_mc_writeACTL -label "mc_write_actl"
.menuFrame.mc.menu add separator 
.menuFrame.mc.menu add command  -command menu_mc_checkACTL -label "mc_check_actl"
.menuFrame.mc.menu add command  -command menu_mc_checkACTLString -label "mc_check_actl_string"
.menuFrame.mc.menu add command  -command menu_mc_checkACTLFile -label "mc_check_actl_file"
.menuFrame.mc.menu add check -label "Generate diagnostic" -variable diagnostic
.menuFrame.mc.menu add check -label "Generate automaton" -variable automaton
.menuFrame.mc.menu add check -label "Minimize automaton" -variable minimize
.menuFrame.mc.menu add check -label "Explain result" -variable explain
.menuFrame.mc.menu add check -label "Trace complete paths" -variable tracepath
.menuFrame.mc.menu add separator
.menuFrame.mc.menu add command  -command menu_mc_generateWCA -label "mc_generate_wca"
.menuFrame.mc.menu add separator
.menuFrame.mc.menu add command  -command mc_about -label "mc_about"

proc mc_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        mc_aboutPkg
        set f [open "$BINDIR/mc.about" r]
	
	while {[gets $f line] >= 0} {
          out "\# "
	  outline $line
	}	
        outline "\#\#\# "
	close $f
}

proc menu_mc_readACTL {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "mc_read_actl"
	set SYNOPSIS "Read ACTL/ACTLW formula."
	set SYNTAX "fname%s formula%s"
        set EXAMPLE "mc_read_actl F1 \"EEF {stop!};\""
	set EXPLANATION "Read formula F1 = \"EEF {stop!}\""
        set BROWSE [list \
          {nonempty "Formula name" 60} \
          {nonempty "ACTL/ACTLW Formula" 60} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_mc_readACTLFile {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "mc_read_actl_file"
	set SYNOPSIS "Read ACTL/ACTLW formulae from file."
	set SYNTAX "file%s"
	set EXAMPLE "mc_read_actl_file safety.actl"
	set EXPLANATION "Read formulae from file safety.actl."
        set BROWSE [list \
	  {file "Select file with ACTL/ACTLW formulae" {{{ACTL/ACTLW formulae} {.actl}}}} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_mc_writeACTL {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "mc_write_actl"
	set SYNOPSIS "Write ACTL/ACTLW formula."
	set SYNTAX "fname%s"
	set EXAMPLE "mc_write_actl F1"
	set EXPLANATION "Write formula F1"
        set BROWSE [list \
          {form "Select formula"} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_mc_checkACTL {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
        global diagnostic
        global automaton
        global explain
        global minimize
        global tracepath
	
	set NAME "mc_check_actl"
	set SYNOPSIS "ACTL/ACTLW model checking"
	set SYNTAX "ptype%d pname%s fname%s param%d"
	set EXAMPLE "mc_check_actl 0 P F1 simple"
	set EXPLANATION "Check ACTL/ACTLW formula F1 on process P"
        set BROWSE [list \
          {name "Select process/composition" proccomp} \
          {form "Select formula"} \
          {optional "Parameter (optional)" 60} \
        ]

	set CMD $NAME
	set CMDEND ""

        set PARAM ""
        if {$diagnostic == 1} {set PARAM "$PARAM | \$mc_diagnostic"}
        if {$automaton == 1} {set PARAM "$PARAM | \$mc_automaton"}
        if {$minimize == 1} {set PARAM "$PARAM | \$mc_minimize"}
        if {$explain == 1} {set PARAM "$PARAM | \$mc_explain"}
        if {$tracepath == 1} {set PARAM "$PARAM | \$mc_tracepath"}

        if {$PARAM != ""} {set PARAM "[string range $PARAM 3 [string length $PARAM]]"}
        if {$PARAM != ""} {set PARAM "\[expr $PARAM\]"}
	
       	commonDialog
}

proc menu_mc_checkACTLString {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
        global diagnostic
        global automaton
        global explain
        global minimize
        global tracepath
	
	set NAME "mc_check_actl_string"
	set SYNOPSIS "ACTL/ACTLW model checking"
	set SYNTAX "ptype%d pname%s formula%s param%d"
        set EXAMPLE "mc_check_actl_string 0 P \"EEF {stop!};\" simple"
	set EXPLANATION "Check ACTLW formula \"EEF {stop!}\" on process P"
        set BROWSE [list \
          {name "Select process/composition" proccomp} \
          {nonempty "ACTL/ACTLW Formula" 60} \
          {optional "Parameter (optional)" 60} \
        ]

	set CMD $NAME
	set CMDEND ""

        set PARAM ""
        if {$diagnostic == 1} {set PARAM "$PARAM | \$mc_diagnostic"}
        if {$automaton == 1} {set PARAM "$PARAM | \$mc_automaton"}
        if {$minimize == 1} {set PARAM "$PARAM | \$mc_minimize"}
        if {$explain == 1} {set PARAM "$PARAM | \$mc_explain"}
        if {$tracepath == 1} {set PARAM "$PARAM | \$mc_tracepath"}

        if {$PARAM != ""} {set PARAM "[string range $PARAM 2 [string length $PARAM]]"}
        if {$PARAM != ""} {set PARAM "\[expr $PARAM\]"}
	
       	commonDialog
}

proc menu_mc_checkACTLFile {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
        global diagnostic
        global automaton
        global explain
        global minimize
        global tracepath
	
	set NAME "mc_check_actl_file"
	set SYNOPSIS "ACTL/ACTLW model checking"
	set SYNTAX "ptype%d pname%s file%s param%d"
	set EXAMPLE "mc_check_actl_file 0 P safety.actl simple"
	set EXPLANATION "Check ACTL/ACTLW formulae in file safety.actl on process P"
        set BROWSE [list \
          {name "Select process/composition" proccomp} \
	  {file "Select file with ACTL/ACTLW formulae" {{{ACTL/ACTLW formulae} {.actl}}}} \
          {optional "Parameter (optional)" 60} \
        ]

	set CMD $NAME
	set CMDEND ""

        set PARAM ""
        if {$diagnostic == 1} {set PARAM "$PARAM | \$mc_diagnostic"}
        if {$automaton == 1} {set PARAM "$PARAM | \$mc_automaton"}
        if {$minimize == 1} {set PARAM "$PARAM | \$mc_minimize"}
        if {$explain == 1} {set PARAM "$PARAM | \$mc_explain"}
        if {$tracepath == 1} {set PARAM "$PARAM | \$mc_tracepath"}

        if {$PARAM != ""} {set PARAM "[string range $PARAM 2 [string length $PARAM]]"}
        if {$PARAM != ""} {set PARAM "\[expr $PARAM\]"}
	
       	commonDialog
}

proc menu_mc_generateWCA {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
	
	set NAME "mc_generate_wca"
	set SYNOPSIS "Generate witness/counterexample automaton"
	set SYNTAX "pname%s fname%s aname%s"
	set EXAMPLE "mc_generate_wca P F1 WCA_P"
	set EXPLANATION "Generate automaton WCA_P for formula F1 on process P"
        set BROWSE [list \
          {name "Select process/composition" proc} \
          {form "Select formula"} \
          {nonempty "Automaton name" 30} \
        ]

	set CMD $NAME
	set CMDEND ""
        set PARAM ""

       	commonDialog
}
