/**CFile*******************************************************************
  PackageName [pa]
  Synopsis    [Package 'pa' is a framework for implementation of 
               process algebrae similar to Milner's CCS and Hoare's CSP.]

  FileName    [paInt.h]
  Revision    [$Revision: 2 $]
  Date        [$Date: 2006-10-05 15:30:29 +0200 (Thu, 05 Oct 2006) $]
  Authors     [Robert Meolic (meolic@uni-mb.si)]
  Description [File paInt.h contains declaration of internal
               data structures.]
  SeeAlso     [pa.h]

  Copyright   [see pa.h]
  ************************************************************************/

#ifndef _PAINT
#define _PAINT

#ifndef TCLOUT
#  define Mi_Out printf
   char outthread;
   int outflag;
   char *out;
#else
#  include <mi.h>
#  define printf Mi_Printf
#endif

#include "pa.h"

/*-----------------------------------------------------------------------*/
/* Constant declarations                                                 */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* Structure declarations                                                */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* Variable declarations                                                 */
/*-----------------------------------------------------------------------*/

/**AutomaticStart*********************************************************/

/*-----------------------------------------------------------------------*/
/* Function prototypes                                                   */
/*-----------------------------------------------------------------------*/

extern void Composition2ProcessR(Pa_Composition *comp, Bdd_Edge F,
                         Bdd_Boolean mark, int *decodingTableR,int procnum);

extern void Composition2ProcessRAS(Pa_Composition *comp, Bdd_Edge F,
                         Bdd_Boolean mark, int minA, int maxA,
                         int *decodingTableR, int *decodingTableS,
                         int procnum);

/**AutomaticEnd***********************************************************/

#endif  /* _PAINT */
