/**CFile*******************************************************************
  PackageName [pa]
  Synopsis    [Package 'pa' is a framework for implementation of 
               process algebrae similar to Milner's CCS and Hoare's CSP.]

  FileName    [paParser.l]
  Revision    [$Revision: 2 $]
  Date        [$Date: 2006-10-05 15:30:29 +0200 (Thu, 05 Oct 2006) $]
  Authors     [Robert Meolic (meolic@uni-mb.si)]
  Description [File paParser.l is a flex file of parser for textual
               description of LTSs.]
  SeeAlso     [pa.h, paInt.h, paParser.y]

  Copyright   [see pa.h]
  ************************************************************************/

PROCESS         process|Process|PROCESS
SORT            sort|Sort|SORT
TRANSITIONS     transitions|Transitions|TRANSITIONS
INITIAL_STATE	("Initial"[ \t]*"state")|("initial"([ \t]*)"state")|("INITIAL"[ \t]*"STATE")
FINAL_STATES	("Final"[ \t]*"states")|("final"([ \t]*)"states")|("FINAL"[ \t]*"STATES")

NAME            [-_A-Za-z0-9][-_A-Za-z0-9]*
ACTION          {NAME}[?!]|"tau"|"Tau"|"TAU"

OUTLINE 	#.*

%%
  int ch, inComm;

"/*"              { for(inComm=1; inComm; )
                    { switch(ch=input())
 			{ case '\n' : break;
			  case '*'  : if (( ch=input()) == '/')
					inComm=0;
				      else  unput(ch);
				break;
                        }
                    }
                  }	

[ ]	          {/* preskok praznih mest */}

[\t\n\r]       	  {/* preskok praznega prostora */}

"'"	          {/* qoutes are ignored */}

"\""	          {/* qoutes are ignored */}

{INITIAL_STATE}	  {return INITIAL_STATE;}

{FINAL_STATES}	  {return FINAL_STATES;}

{PROCESS}         {return PROCESS;}

{SORT}            {return SORT;}

{TRANSITIONS}     {return TRANSITIONS;}

GATES             {return GATES;}

ACTIONS           {return ACTIONS;}

{ACTION}	  {
                   yylval.word = strdup(yytext);
                   return ACTION;
                  }

{NAME}		  {
                   yylval.word = strdup(yytext);
                   return NAME;
                  }

","	          {return yytext[0];}
"."	          {return yytext[0];}
"+"	          {return yytext[0];}
"="	          {return yytext[0];}

{OUTLINE}	  {
                   yylval.word = strdup(yytext);
                   return OUTLINE;
                  }

.                 {
                   return UNKNOWN;
                  }
%%
