/**CHeaderFile*************************************************************
  PackageName [mi]
  FileName    [mi.h]
  Authors     [Robert Meolic (meolic@uni-mb.si)]

  Revision    [$Revision: 2 $]
  Date        [$Date: 2006-10-05 15:34:29 +0200 (Thu, 05 Oct 2006) $]
  Synopsis    []
  Description []
  SeeAlso     [mi.c]
  Copyright   [Copyright (C) 2000-2004 Robert Meolic
               This program is free software; you can redistribute it
               and/or modify it under the terms of the GNU General Public
               License (version 2) as published by the Free Software
               Foundation.

               This program is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 59 Temple Place, Suite 330,
               Boston, MA  02111-1307 USA.]
  ************************************************************************/

#ifndef _MI
#define _MI

#include <tcl.h>

/* ON WIN32 THERE HAS TO BE DEFINED ESTWIN32 */
/* ON UNIX THERE HAS TO BE DEFINED ESTUNIX */

#ifdef ESTUNIX
#  ifndef EXTERN
#  define EXTERN extern
#  endif
#endif

#ifdef ESTWIN32
#ifndef TCL
#    ifdef BUILD_MI
#      undef EXTERN
#      define EXTERN __declspec (dllexport)
#    else
#      ifdef USE_MI
#        undef EXTERN
#        define EXTERN __declspec (dllimport)
#      else
#        define EXTERN extern
#      endif
#    endif
#else
#    ifdef BUILD_MI
#      undef TCL_STORAGE_CLASS
#      define TCL_STORAGE_CLASS DLLEXPORT
#    else
#      undef TCL_STORAGE_CLASS
#      define TCL_STORAGE_CLASS DLLIMPORT
#    endif
#endif
#endif

EXTERN char outthread;
EXTERN int outflag;
EXTERN char *out;
EXTERN Tcl_Interp *outinterp;

EXTERN void Mi_AboutPkg();

EXTERN int Mi_Printf(char *format, ...);

EXTERN int Mi_Out(char *format, ...);

#endif  /* _MI */

